# frozen_string_literal: true
module Hermes
  module Api
    module Dmo
      class DocumentationController <  ActionController::Base
        # This action uses query string parameters because it gets run
        # by an HTTP GET request, but this does not make any difference
        # to the way in which the parameters are accessed. The URL for
        # this action would look like this in order to list activated
        # clients: /clients?status=activated
        def show_doc
          @md_doc ="" 
          Dir.glob(File.join(Rails.root,"packages","hermes", "app", "assets", "docs", "doc", "*")).sort.each do |file_name|
            @md_doc += File.read(file_name) + "\n"
          end

         render template: "show_doc"
        end

        def show_changelog
          @md_doc = File.read(File.join(Rails.root,"packages","hermes", "changelog.md"))
          render template: "show_doc"
        end

        def show_old_changelog
          @md_doc = File.read(File.join(Rails.root,"packages","hermes", "old-changelog.md"))
          render template: "show_doc"
        end

      end
    end
  end
end
