module Hermes
  module BoClient
    class UpdateOrientationTask < BaseTask
      
      def initialize(options = {})
        @xsd = "demandeOrientationsReponse.xsd"
        super(options)
      end
      
      def endpoint
        "/ws/rest/als/demande/v1/demandeOrientations/#{mapping.main_object.als_id}"
      end 
      
      task_name 'UpdateOrientation'
      type_flux 'BIEN'
      mapping 'Hermes::BoClient::Mappings::HousingRequestMap'
      
      params *%i[
      ]
      
      def to_xml
        nil
      end

      def validate_xml(xml = nil)
        nil
      end 

      def execute(client = Hermes::BoClient::Client.new)
        if Rails.env.test?
          pn = Pathname.new([Hermes::Engine.root, %w[spec xml_bouchon update_orientation], mapping.main_object.als_id + ".xml"].flatten.join('/').to_s)

          code = 404
          body = nil

          if pn.exist?
            code = 200
            body = File.read(pn)
          end

          return ExecuteSopraTaskJob.after_response(code, body, 'Hermes::HousingRequest', mapping.main_object.id, nil, 'update_orientation')
        end 
        ExecuteSopraTaskJob.perform_now(endpoint, nil, 'get', mapping.main_object.class.name, mapping.main_object.id.to_s, nil , 'update_orientation')
      end


    end
  end
end
