require 'rails_helper'

RSpec.describe ExecuteFlux36TaskJob do
  subject { ExecuteFlux36TaskJob }
  let!(:hr) { create(:complete_request)}

  before(:each) do
  end

  it 'work' do
    hr.set(als_id: '1', entity_id: '1', first_flux_30_sended: true)
    result = subject.perform_now(hr.id.to_s)
    expect(result.class).to eq(ExecuteSopraTaskJob)
  end

  it 'reprogram no params' do 
    result = subject.perform_now(hr.id.to_s)
    expect(result.class).to eq(subject)
  end 

  it 'create error when max try' do 
    expect(Log.where(code: 'FLUX_36_ERROR_MISSING_ATTRIBUTES').count).to eq(0)

    result = subject.perform_now(hr.id.to_s)
    subject.perform_later(hr.id.to_s)
    (0..5).each do |i|
      last_job = if i == 0
        enqueued_jobs.select{|a| a[:job] == subject }.first
      else
        enqueued_jobs.select{|a| a[:job] == subject && a[:args][1] == i }.first
      end 
      last_job[:job].perform_now(*deserialize_argument(last_job[:args]))
    end 
    Hermes::LogJob.perform_now
    expect(Log.where(code: 'FLUX_36_ERROR_WRONG_ATTRIBUTES').count).to eq(1)
  end 
end
